
restart;
currentdir();
with(PolynomialTools):
with(ListTools):
read(recden);
monic:=proc(a) #monic makes rpolys monic
 if getpoly(a)=0 then a else mulrpoly(invrpoly(lcrpoly(a)),a); fi; 
end proc:
read "MRES.mpl";
#Benchmark 1, 
M1:=z1^2-2:
M2:=z2^2-3:
M3:=z3^2-5:
M4:=z4^2-7:
c:=rand(1..9):
#co creats random polynomials in Z=[z1,..zn] with random coeffs in [1,9)
co:=proc(Z,d,c) 
local n,i;
   n:=nops(Z);
   if n=0 then return c(); fi;
   add(co(Z[1..-2],d[1..-2],c)*Z[-1]^i,i=0..d[-1]-1);
end:
m:=2: #degree of a and b
Z:=[z1,z2,z3,z4]:
dl:=[2,2,2,2]:
a:=rpoly(add(add(co(Z,dl,c)*x^i*y^j,j=0..m),i=0..m),[x,y,z4,z3,z2,z1],[M1,M2,M3,M4]):
b:=rpoly(add(add(co(Z,dl,c)*x^i*y^j,j=0..m),i=0..m),[x,y,z4,z3,z2,z1],[M1,M2,M3,M4]):
#MRS
timings := true;
for k to 7 do
  f1:=powrpoly(a,k);
  f2:=powrpoly(b,k);
  printf("d=%d  deg(f1,x)=%d  deg(f1,y)=%d  deg(f2,x)=%d  deg(f2,y)=%d  \n",
     k,degrpoly(f1,x),degrpoly(f1,y),degrpoly(f2,x),degrpoly(f2,y));
  t:=time():
  Mahsa1:=timelimit(1000,MRS(f1,f2,y,nextprime(2^30)));
  tMRS1:=time()-t;
printf("deg(r,x)=%d\n",degrpoly(Mahsa1[1]));
od:
#MRS2
timings := true;
for k to 7 do
  f1:=powrpoly(a,k);
  f2:=powrpoly(b,k);
  printf("d=%d  deg(f1,x)=%d  deg(f1,y)=%d  deg(f2,x)=%d  deg(f2,y)=%d  \n",
     k,degrpoly(f1,x),degrpoly(f1,y),degrpoly(f2,x),degrpoly(f2,y));
  t:=time():
  Mahsa2:=timelimit(1000,MRS2(f1,f2,y,nextprime(2^30)));
  tMRS1:=time()-t; 
printf("deg(r,x)=%d\n",degrpoly(Mahsa2[1]));
od:
#Benchmark 2:  m1 and m2 are fixed and I m3 will be changed to get differen values for d=d1*d2*d3
d1,d2:=2,2;
m1 := z1^2-2;
m2 := z2^2-3;
Z:=[z1,z2,z3];
#MRS
timings := true;
m:=5;
a:=expand(add(add(co(Z,dl,c)*x^i*y^j,j=0..m),i=0..m)):
b:=expand(add(add(co(Z,dl,c)*x^i*y^j,j=0..m),i=0..m)):
for i from 4 to 16 do
     m3 := add(z3^j,j=0..i)+z1*z2:
     f1:=rpoly(a,[x,y,z3,z2,z1],[m1,m2,m3]):
     f2:=rpoly(b,[x,y,z3,z2,z1],[m1,m2,m3]):
     d:=d1*d2*degree(m3,z3):
     printf("d=%d \n",d);
     t:=time():
     Mahsa1:=timelimit(1000,MRS(f1,f2,y,nextprime(2^30)));
     tMRS1:=time()-t;
     printf("deg(Mahsa1,x)=%d  \n",degrpoly(Mahsa1[1],x));
  od:



#MRS2
timings := true;
m:=5;
a:=expand(add(add(co(Z,dl,c)*x^i*y^j,j=0..m),i=0..m)):
b:=expand(add(add(co(Z,dl,c)*x^i*y^j,j=0..m),i=0..m)):
for i from 4 to 16 do
     i:=2*i;
     m3 := add(z3^j,j=0..i)+z1*z2:
     f1:=rpoly(a,[x,y,z3,z2,z1],[m1,m2,m3]):
     f2:=rpoly(b,[x,y,z3,z2,z1],[m1,m2,m3]):
     d:=d1*d2*degree(m3,z3):
     printf("d=%d \n",d);
     t:=time():
     Mahsa1:=timelimit(1000,MRS2(f1,f2,y,nextprime(2^30)));
     tMRS1:=time()-t;
     printf("deg(Mahsa1,x)=%d  \n",degrpoly(Mahsa1[1],x));
  od:
